import { JSX as JSX_2 } from 'react';
import { ReactNode } from 'react';

export declare function DatePicker({ show, values, title, columnsType, minDate, maxDate, teleport, confirmButtonText, cancelButtonText, formatYearLabel, formatMonthLabel, formatDayLabel, onConfirm, onClose, onCancel, onOpen, onClosed, }: Props_2): JSX_2.Element;

export declare type DatePickerColumnType = 'year' | 'month' | 'day';

export declare type Direction = '' | 'vertical' | 'horizontal';

export declare function Picker<T>({ show, values, title, columns, linkage, loading, loadingSlot, emptySlot, teleport, confirmButtonText, cancelButtonText, columnsFieldNames, onConfirm, onClose, onChange, onCancel, onOpen, onClosed, }: Props<T>): JSX_2.Element;

export declare type PickerColumn<T = string | number> = Array<PickerOption<T> | undefined>;

export declare type PickerColumnsType = 'single' | 'multiple' | 'cascade';

export declare interface PickerFields {
    label?: string;
    value?: string;
    children?: string;
}

export declare type PickerFormatLabel = (label: string) => string;

export declare interface PickerOption<T> {
    label?: string | number;
    value?: T;
    children?: PickerColumn<T>;
    [key: PropertyKey]: any;
}

export declare type PickerSelectedValues<T = string | number> = Array<PickerOption<T>['value']>;

declare interface Props<T = string | number> {
    show: boolean;
    values?: T[];
    title?: string;
    columns: PickerColumn<T> | PickerColumn<T>[];
    linkage?: boolean;
    loading?: boolean;
    loadingSlot?: ReactNode;
    emptySlot?: ReactNode;
    teleport?: Element | DocumentFragment;
    confirmButtonText?: string;
    cancelButtonText?: string;
    columnsFieldNames?: PickerFields;
    onConfirm?: (values: T[]) => void;
    onClose: () => void;
    onChange?: (values: T[]) => void;
    onCancel?: () => void;
    onOpen?: () => void;
    onClosed?: () => void;
}

declare interface Props_2 {
    show: boolean;
    values?: number[];
    title?: string;
    columnsType?: DatePickerColumnType[];
    minDate?: Date;
    maxDate?: Date;
    teleport?: Element | DocumentFragment;
    confirmButtonText?: string;
    cancelButtonText?: string;
    formatYearLabel?: PickerFormatLabel;
    formatMonthLabel?: PickerFormatLabel;
    formatDayLabel?: PickerFormatLabel;
    onConfirm?: (values: number[]) => void;
    onClose: () => void;
    onCancel?: () => void;
    onOpen?: () => void;
    onClosed?: () => void;
}

declare interface Props_3 {
    show: boolean;
    values?: number[];
    title?: string;
    columnsType?: TimePickerColumnType[];
    minTime?: string;
    maxTime?: string;
    teleport?: Element | DocumentFragment;
    confirmButtonText?: string;
    cancelButtonText?: string;
    formatHourLabel?: PickerFormatLabel;
    formatMinuteLabel?: PickerFormatLabel;
    formatSecondLabel?: PickerFormatLabel;
    onConfirm?: (values: number[]) => void;
    onClose: () => void;
    onCancel?: () => void;
    onOpen?: () => void;
    onClosed?: () => void;
}

export declare function TimePicker({ show, values, title, columnsType, minTime, maxTime, teleport, confirmButtonText, cancelButtonText, formatHourLabel, formatMinuteLabel, formatSecondLabel, onConfirm, onClose, onCancel, onOpen, onClosed, }: Props_3): JSX_2.Element;

export declare type TimePickerColumnType = 'hour' | 'minute' | 'second';

export declare type TimeSelection = Record<TimePickerColumnType, number>;

export { }
