import { AllowedComponentProps } from 'vue';
import { ComponentCustomProps } from 'vue';
import { ComponentOptionsMixin } from 'vue';
import { ComponentProvideOptions } from 'vue';
import { DefineComponent } from 'vue';
import { PublicProps } from 'vue';
import { ShallowUnwrapRef } from 'vue';
import { VNode } from 'vue';
import { VNodeProps } from 'vue';

declare type __VLS_PrettifyLocal<T> = {
    [K in keyof T]: T[K];
} & {};

export declare const DatePicker: DefineComponent<Props_2, {}, {}, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
"update:modelValue": (values: number[]) => any;
open: () => any;
closed: () => any;
"update:show": (isShow: boolean) => any;
confirm: (values: number[]) => any;
cancel: () => any;
}, string, PublicProps, Readonly<Props_2> & Readonly<{
"onUpdate:modelValue"?: ((values: number[]) => any) | undefined;
onOpen?: (() => any) | undefined;
onClosed?: (() => any) | undefined;
"onUpdate:show"?: ((isShow: boolean) => any) | undefined;
onConfirm?: ((values: number[]) => any) | undefined;
onCancel?: (() => any) | undefined;
}>, {
title: string;
columnsType: DatePickerColumnType[];
minDate: Date;
maxDate: Date;
formatYearLabel: PickerFormatLabel;
formatMonthLabel: PickerFormatLabel;
formatDayLabel: PickerFormatLabel;
}, {}, {}, {}, string, ComponentProvideOptions, false, {}, any>;

export declare type DatePickerColumnType = 'year' | 'month' | 'day';

export declare type Direction = '' | 'vertical' | 'horizontal';

export declare const Picker: <T extends string | number>(__VLS_props: NonNullable<Awaited<typeof __VLS_setup>>["props"], __VLS_ctx?: __VLS_PrettifyLocal<Pick<NonNullable<Awaited<typeof __VLS_setup>>, "attrs" | "emit" | "slots">>, __VLS_expose?: NonNullable<Awaited<typeof __VLS_setup>>["expose"], __VLS_setup?: Promise<{
    props: __VLS_PrettifyLocal<Pick<Partial<{}> & Omit<{
        readonly "onUpdate:modelValue"?: ((values: T[]) => any) | undefined;
        readonly onOpen?: (() => any) | undefined;
        readonly onClosed?: (() => any) | undefined;
        readonly "onUpdate:show"?: ((show: boolean) => any) | undefined;
        readonly onConfirm?: ((values: T[]) => any) | undefined;
        readonly onCancel?: (() => any) | undefined;
    } & VNodeProps & AllowedComponentProps & ComponentCustomProps, never>, "onUpdate:modelValue" | "onOpen" | "onClosed" | "onUpdate:show" | "onConfirm" | "onCancel"> & Props<T> & Partial<{}>> & PublicProps;
    expose(exposed: ShallowUnwrapRef<    {}>): void;
    attrs: any;
    slots: {
        loading?(_: {}): any;
        empty?(_: {}): any;
    };
    emit: ((evt: "update:modelValue", values: T[]) => void) & ((evt: "open") => void) & ((evt: "closed") => void) & ((evt: "update:show", show: boolean) => void) & ((evt: "confirm", values: T[]) => void) & ((evt: "cancel") => void);
}>) => VNode & {
    __ctx?: Awaited<typeof __VLS_setup>;
};

export declare type PickerColumn<T = string | number> = Array<PickerOption<T> | undefined>;

export declare type PickerColumnsType = 'single' | 'multiple' | 'cascade';

export declare interface PickerFields {
    label?: string;
    value?: string;
    children?: string;
}

export declare type PickerFormatLabel = (label: string) => string;

export declare interface PickerOption<T> {
    label?: string | number;
    value?: T;
    children?: PickerColumn<T>;
    [key: PropertyKey]: any;
}

export declare type PickerSelectedValues<T = string | number> = Array<PickerOption<T>['value']>;

declare interface Props<T> {
    show: boolean;
    modelValue?: T[];
    title?: string;
    columns: PickerColumn<T> | PickerColumn<T>[];
    linkage?: boolean;
    loading?: boolean;
    teleport?: string | Element;
    confirmButtonText?: string;
    cancelButtonText?: string;
    columnsFieldNames?: PickerFields;
}

declare interface Props_2 {
    show: boolean;
    modelValue?: number[];
    title?: string;
    columnsType?: DatePickerColumnType[];
    minDate?: Date;
    maxDate?: Date;
    teleport?: string | Element;
    confirmButtonText?: string;
    cancelButtonText?: string;
    formatYearLabel?: PickerFormatLabel;
    formatMonthLabel?: PickerFormatLabel;
    formatDayLabel?: PickerFormatLabel;
}

declare interface Props_3 {
    show: boolean;
    modelValue?: number[];
    title?: string;
    columnsType?: TimePickerColumnType[];
    minTime?: string;
    maxTime?: string;
    teleport?: string | Element;
    confirmButtonText?: string;
    cancelButtonText?: string;
    formatHourLabel?: PickerFormatLabel;
    formatMinuteLabel?: PickerFormatLabel;
    formatSecondLabel?: PickerFormatLabel;
}

export declare const TimePicker: DefineComponent<Props_3, {}, {}, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
"update:modelValue": (values: number[]) => any;
open: () => any;
closed: () => any;
"update:show": (isShow: boolean) => any;
confirm: (values: number[]) => any;
cancel: () => any;
}, string, PublicProps, Readonly<Props_3> & Readonly<{
"onUpdate:modelValue"?: ((values: number[]) => any) | undefined;
onOpen?: (() => any) | undefined;
onClosed?: (() => any) | undefined;
"onUpdate:show"?: ((isShow: boolean) => any) | undefined;
onConfirm?: ((values: number[]) => any) | undefined;
onCancel?: (() => any) | undefined;
}>, {
title: string;
columnsType: TimePickerColumnType[];
formatHourLabel: PickerFormatLabel;
formatMinuteLabel: PickerFormatLabel;
formatSecondLabel: PickerFormatLabel;
}, {}, {}, {}, string, ComponentProvideOptions, false, {}, any>;

export declare type TimePickerColumnType = 'hour' | 'minute' | 'second';

export declare type TimeSelection = Record<TimePickerColumnType, number>;

export { }
